gtkmm 3.6.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gtk::NumerableIcon Class Reference

A Gio::Icon that allows numbered emblems. More...

Inheritance diagram for Gtk::NumerableIcon:
[legend]

List of all members.

## Public Member Functions
virtual | ~NumerableIcon ()
GtkNumerableIcon* | gobj ()
| Provides access to the underlying C GObject.
const GtkNumerableIcon* | gobj () const
| Provides access to the underlying C GObject.
GtkNumerableIcon* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the Gtk::StyleContext used by the icon for theming, or `0` if there's none.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the Gtk::StyleContext used by the icon for theming, or `0` if there's none.
void | set_style_context (const Glib::RefPtr< StyleContext >& style)
| Updates the icon to fetch theme information from the given Gtk::StyleContext.
int | get_count () const
| Returns the value currently displayed by self.
void | set_count (int count)
| Sets the currently displayed value of self to count.
Glib::ustring | get_label () const
| Returns the currently displayed label of the icon, or `0`.
void | set_label (const Glib::ustring& label)
| Sets the currently displayed value of self to the string in label.
void | set_background_gicon (const Glib::RefPtr< Gio::Icon >& icon)
| Updates the icon to use icon as the base background image.
Glib::RefPtr< Gio::Icon > | get_background_gicon ()
| Returns the Icon that was set as the base background image, or `0` if there's none.
Glib::RefPtr< const Gio::Icon > | get_background_gicon () const
| Returns the Icon that was set as the base background image, or `0` if there's none.
void | set_background_icon_name (const Glib::ustring& icon_name)
| Updates the icon to use the icon named icon_name from the current icon theme as the base background image.
Glib::ustring | get_background_icon_name () const
| Returns the icon name used as the base background image, or `0` if there's none.
Glib::PropertyProxy< int > | property_count ()
| The count of the emblem currently displayed.
Glib::PropertyProxy_ReadOnly< int > | property_count () const
| The count of the emblem currently displayed.
Glib::PropertyProxy < Glib::ustring > | property_label ()
| The label to be displayed over the icon.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_label () const
| The label to be displayed over the icon.
Glib::PropertyProxy < Glib::RefPtr< StyleContext > > | property_style_context ()
| The style context to theme the icon appearance.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< StyleContext > > | property_style_context () const
| The style context to theme the icon appearance.
Glib::PropertyProxy < Glib::RefPtr< Gio::Icon > > | property_background_icon ()
| The icon for the number emblem background.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gio::Icon > > | property_background_icon () const
| The icon for the number emblem background.
Glib::PropertyProxy < Glib::ustring > | property_background_icon_name ()
| The icon name for the number emblem background.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_background_icon_name () const
| The icon name for the number emblem background.
Public Member Functions inherited from Gio::EmblemedIcon
virtual | ~EmblemedIcon ()
Glib::RefPtr< Icon > | get_icon ()
Glib::RefPtr< const Icon > | get_icon () const
Glib::ListHandle< Glib::RefPtr < Emblem > > | get_emblems ()
void | add_emblem (const Glib::RefPtr< Emblem > &emblem)
void | clear_emblems ()
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj_copy () const
virtual | ~Icon ()
guint | hash () const
std::string | to_string () const
bool | equal (const Glib::RefPtr< Icon > &other) const
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
virtual | ~Interface ()
Glib::RefPtr< Gio::EmblemedIcon > | wrap (GEmblemedIcon *object, bool take_copy=false)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Glib::RefPtr< Gio::Icon > | wrap (GIcon *object, bool take_copy=false)
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr < NumerableIcon > | create (const Glib::RefPtr< Gio::Icon >& icon)
static Glib::RefPtr < NumerableIcon > | create (const Glib::RefPtr< Gio::Icon >& icon, const Glib::RefPtr< StyleContext >& context)
Static Public Member Functions inherited from Gio::EmblemedIcon
static Glib::RefPtr< EmblemedIcon > | create (const Glib::RefPtr< Icon > &icon, const Glib::RefPtr< Emblem > &emblem)
static void | add_interface (GType gtype_implementer)
static Glib::RefPtr< Icon > | create (const std::string &str)

## Protected Member Functions
| NumerableIcon (const Glib::RefPtr< Gio::Icon >& icon)
| NumerableIcon (const Glib::RefPtr< Gio::Icon >& icon, const Glib::RefPtr< StyleContext >& style_context)
Protected Member Functions inherited from Gio::EmblemedIcon
| EmblemedIcon (const Glib::RefPtr< Icon > &icon)
| EmblemedIcon (const Glib::RefPtr< Icon > &icon, const Glib::RefPtr< Emblem > &emblem)
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
virtual | ~Object ()
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
virtual | ~ObjectBase ()=0
void | initialize (GObject *castitem)
| Icon ()

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::NumerableIcon > | wrap (GtkNumerableIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gio::EmblemedIcon
typedef void(* | DestroyNotify )(gpointer data)
Public Types inherited from Glib::Object

## Detailed Description

A Gio::Icon that allows numbered emblems.

GtkNumerableIcon is a subclass of EmblemedIcon that can show a number or short string as an emblem. The number can be overlayed on top of another emblem, if desired.

It supports theming by taking font and color information from a provided StyleContext. See set_style_context().

Since gtkmm 3.0:

## Constructor & Destructor Documentation

virtual Gtk::NumerableIcon::~NumerableIcon | ( |  | ) |
| virtual

Gtk::NumerableIcon::NumerableIcon | ( | const Glib::RefPtr< Gio::Icon > & | icon | ) |
| explicit protected

Gtk::NumerableIcon::NumerableIcon | ( | const Glib::RefPtr< Gio::Icon > & | icon,
|  | const Glib::RefPtr< StyleContext >& | style_context
| ) |  |
| explicit protected

## Member Function Documentation

static Glib::RefPtr<NumerableIcon> Gtk::NumerableIcon::create | ( | const Glib::RefPtr< Gio::Icon > & | icon | ) |
| static

Reimplemented from Gio::EmblemedIcon.

static Glib::RefPtr<NumerableIcon> Gtk::NumerableIcon::create | ( | const Glib::RefPtr< Gio::Icon > & | icon,
|  | const Glib::RefPtr< StyleContext >& | context
| ) |  |
| static

Glib::RefPtr<Gio::Icon> Gtk::NumerableIcon::get_background_gicon | ( |  | ) |

Returns the Icon that was set as the base background image, or `0` if there's none.

The caller of this function does not own a reference to the returned Icon.

Since gtkmm 3.0:

Returns:
  A Icon, or `0`.

Glib::RefPtr<const Gio::Icon> Gtk::NumerableIcon::get_background_gicon | ( |  | ) | const

Returns the Icon that was set as the base background image, or `0` if there's none.

The caller of this function does not own a reference to the returned Icon.

Since gtkmm 3.0:

Returns:
  A Icon, or `0`.

Glib::ustring Gtk::NumerableIcon::get_background_icon_name | ( |  | ) | const

Returns the icon name used as the base background image, or `0` if there's none.

Since gtkmm 3.0:

Returns:
  An icon name, or `0`.

int Gtk::NumerableIcon::get_count | ( |  | ) | const

Returns the value currently displayed by self.

Since gtkmm 3.0:

Returns:
  The currently displayed value.

Glib::ustring Gtk::NumerableIcon::get_label | ( |  | ) | const

Returns the currently displayed label of the icon, or `0`.

Since gtkmm 3.0:

Returns:
  The currently displayed label.

Glib::RefPtr<StyleContext> Gtk::NumerableIcon::get_style_context | ( |  | ) |

Returns the Gtk::StyleContext used by the icon for theming, or `0` if there's none.

Since gtkmm 3.0:

Returns:
  A Gtk::StyleContext, or `0`. This object is internal to GTK+ and should not be unreffed. Use Glib::object_ref() if you want to keep it around.

Glib::RefPtr<const StyleContext> Gtk::NumerableIcon::get_style_context | ( |  | ) | const

Returns the Gtk::StyleContext used by the icon for theming, or `0` if there's none.

Since gtkmm 3.0:

Returns:
  A Gtk::StyleContext, or `0`. This object is internal to GTK+ and should not be unreffed. Use Glib::object_ref() if you want to keep it around.

static GType Gtk::NumerableIcon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Reimplemented from Gio::EmblemedIcon.

GtkNumerableIcon* Gtk::NumerableIcon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::EmblemedIcon.

const GtkNumerableIcon* Gtk::NumerableIcon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::EmblemedIcon.

GtkNumerableIcon* Gtk::NumerableIcon::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::EmblemedIcon.

Glib::PropertyProxy< Glib::RefPtr<Gio::Icon> > Gtk::NumerableIcon::property_background_icon | ( |  | ) |

The icon for the number emblem background.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::Icon> > Gtk::NumerableIcon::property_background_icon | ( |  | ) | const

The icon for the number emblem background.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::NumerableIcon::property_background_icon_name | ( |  | ) |

The icon name for the number emblem background.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::NumerableIcon::property_background_icon_name | ( |  | ) | const

The icon name for the number emblem background.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::NumerableIcon::property_count | ( |  | ) |

The count of the emblem currently displayed.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::NumerableIcon::property_count | ( |  | ) | const

The count of the emblem currently displayed.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::NumerableIcon::property_label | ( |  | ) |

The label to be displayed over the icon.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::NumerableIcon::property_label | ( |  | ) | const

The label to be displayed over the icon.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<StyleContext> > Gtk::NumerableIcon::property_style_context | ( |  | ) |

The style context to theme the icon appearance.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<StyleContext> > Gtk::NumerableIcon::property_style_context | ( |  | ) | const

The style context to theme the icon appearance.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::NumerableIcon::set_background_gicon | ( | const Glib::RefPtr< Gio::Icon > & | icon | ) |

Updates the icon to use icon as the base background image.

If icon is `0`, self will go back using style information or default theming for its background image.

If this method is called and an icon name was already set as background for the icon, icon will be used, i.e. the last method called between set_background_gicon() and set_background_icon_name() has always priority.

Since gtkmm 3.0:

Parameters:

  icon | A Icon, or `0`.

void Gtk::NumerableIcon::set_background_icon_name | ( | const Glib::ustring & | icon_name | ) |

Updates the icon to use the icon named icon_name from the current icon theme as the base background image.

If icon_name is `0`, self will go back using style information or default theming for its background image.

If this method is called and a Icon was already set as background for the icon, icon_name will be used, i.e. the last method called between set_background_icon_name() and set_background_gicon() has always priority.

Since gtkmm 3.0:

Parameters:

  icon_name | An icon name, or `0`.

void Gtk::NumerableIcon::set_count | ( | int | count | ) |

Sets the currently displayed value of self to count.

The numeric value is always clamped to make it two digits, i.e. between -99 and 99. Setting a count of zero removes the emblem. If this method is called, and a label was already set on the icon, it will automatically be reset to `0` before rendering the number, i.e. the last method called between set_count() and set_label() has always priority.

Since gtkmm 3.0:

Parameters:

  count | A number between -99 and 99.

void Gtk::NumerableIcon::set_label | ( | const Glib::ustring & | label | ) |

Sets the currently displayed value of self to the string in label.

Setting an empty label removes the emblem.

    Note that this is meant for displaying short labels, such as
    roman numbers, or single letters. For roman numbers, consider
    using the Unicode characters U+2160 - U+217F. Strings longer
    than two characters will likely not be rendered very well.

    If this method is called, and a number was already set on the
    icon, it will automatically be reset to zero before rendering
    the label, i.e. the last method called between
    set_label() and set_count()
    has always priority.

    \xrefitem since_3_0 188. @param label A short label, or <tt>0</tt>.

void Gtk::NumerableIcon::set_style_context | ( | const Glib::RefPtr< StyleContext >& | style | ) |

Updates the icon to fetch theme information from the given Gtk::StyleContext.

Since gtkmm 3.0:

Parameters:

  style | A Gtk::StyleContext.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::NumerableIcon > wrap | ( | GtkNumerableIcon * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/numerableicon.h